/* cgi_com.c 19981229 */
/* common functions for CGI */

#ifndef USE_FLOCK
	#define USE_FLOCK	1
#endif /* USE_FLOCK */

#ifndef CGI_DEBUG
	#define CGI_DEBUG 0
#endif /* CGI_DEBUG */

#ifdef DOSCGI_DEBUG
	#undef CGI_DEBUG
	#define CGI_DEBUG	1
	#undef USE_FLOCK
	#define USE_FLOCK	0
#endif /* DOSCGI_DEBUG */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "cgi_com.h"

#if USE_FLOCK
	#include <sys/types.h>
	#include <unistd.h>
	#include <fcntl.h>
#endif /* USE_FLOCK */

/* ץȥ */
void cgi_strexp(char *src, char *endp, char *dst);

void cgi_initform(void)
{
#if CGI_DEBUG
	fprintf(stderr, "CGI form init.\n");
#endif /* CGI_DEBUG */

	return;
} /* end of func */

char *cgi_getform(const char *str)
{
#define MAX_STR0	256
	int safe = 0;
	int end = 0;
	char *qstr;
	char *p;
	char *s;
	char q[MAX_STR0];
	static char result[MAX_STR0];

	qstr = getenv("QUERY_STRING");
	if (qstr == NULL) goto FORM_ERR;

	do {
#ifdef DOSCGI_DEBUG
		p = strchr(qstr, '#');
#else
		p = strchr(qstr, '=');
#endif /* DOSCGI_DEBUG */
		if (p == NULL) goto FORM_ERR;
		if (p > qstr + MAX_STR0) goto FORM_ERR;

		cgi_strexp(qstr, p, q);
		p += 1;
		s = strchr(p, '&');
		if (s == NULL) {
			s = strchr(p, '\0');
			end = 1;
		}
		if (s > p + MAX_STR0) goto FORM_ERR;

		if (strcmp(str, q) == 0) {
			cgi_strexp(p, s, result);
#if CGI_DEBUG
		fprintf(stderr, "CGI form %s=%s\n", str, result);
#endif /* CGI_DEBUG */
			return result;
		}

		qstr = s + 1;
	} while (end == 0 && ++safe < 99);

	FORM_ERR:
#if CGI_DEBUG
		fprintf(stderr, "CGI form %s not found\n", str);
#endif /* CGI_DEBUG */
	return NULL;
} /* end of func */

void cgi_strexp(char *src, char *endp, char *dst)
{
	int c;

	while(src < endp) {
		switch(*src) {
		case '\0':
			goto END; /*  */
			break;
		case '%':
			c = 0x20; /* ǰΤ */
			src++;
			sscanf(src, "%2X", &c);
			*dst++ = c;
			if (*src == '\0' || *(src + 1) == '\0')
				goto END; /*  */
			src += 2;
			break;
		case '+':
			*dst++ = 0x20;
			src++;
			break;
		default:
			*dst++ = *src;
			src++;
			break;
		} /* switch */
	} /* while */

	END:
	*dst = '\0';
	return;
} /* end of func */

void cgi_accounting(const char *filename)
{
	char *host;
	FILE *fp;
	int fd;
	time_t t;
	char tstr[32];
	char *c;
	int i = 0;

	host = getenv("REMOTE_HOST");
	if (host == NULL) {
		host = getenv("REMOTE_ADDR");
		if (host == NULL) host = "(null)"; /* ۤȤͭʤ */
	}

	t = time(NULL); /* ߻⵭Ͽ */
	strcpy(tstr, ctime(&t));

	c = strstr(tstr, "\n"); /* \n */
	*c = '\0';

	fp = fopen(filename, "a");
	if (fp == NULL) return; /* 顼ΤȤ꥿ */
	fd = fileno(fp);

#if USE_FLOCK
#if 0 /* ʰ */
	if (flock(fd, LOCK_EX) != 0) {
		goto FCLOSE; /* 顼ΤȤ */
	}
#endif /* 0 */
#if 1 /* ʥ(ΤĤ) */
	while (flock(fd, LOCK_EX | LOCK_NB) != 0) { 
			/* ե뤬åƤƤ֥åʤ */
		if (i++ >= 11) goto FCLOSE; /* 11ʾ奨顼ΤȤ򤢤 */
		usleep((5 + getpid() & 0x0f) * 10000L);
			/* ޥñ̤ǥ꡼ */
			/* usleep(3)¸ߤʤȤϡselect(2)sleep(3)Ȥ */
	}
#endif /* 1 */
	fseek(fp, 0L, SEEK_END); /* ǰΤ */
#endif /* USE_FLOCK */

	fprintf(fp, "%s %s %d\n", tstr, host, i);

#if USE_FLOCK
	flock(fd, LOCK_UN);
#endif /* USE_FLOCK */

	FCLOSE: /* 󡢱 */
	fclose(fp);
	return;
} /* end of func */

