/* cellular.c 19990404 19990618 19990807 20000703 */
const long cellular_revision = 20000703;

#include <stdio.h>
#include "k_defs.h"
#include "keitai.h"
#include "k_priv.h"

#define MAX_PLAN 9

/* ץȥ */
static void komi_calc(long tm, int tm2, long *r, 
float *stdt, int *px);

/* ܸ */
static const int ct_rinsetu[][9] = {
	/* ä˵ҤʤΤϥɥܸϿĢ¬ */
	/* CT1: */
	{aomori, -1},
	/* CT2: ѥ199812*/
	{hokkaido, ibaraki, tochigi, gunma, nagano, toyama, -1},
	/* CT4: */
	{gifu, kyoto, siga, niigata, nagano, -1},
	/* CT6: ѥ(98-09) */
	{mie, gifu, fukui, tottori, okayama, kagawa, tokusima, -1},
	/* CT7: (1999.1) */
	{hyogo, kagawa, ehime, tokusima, fukuoka, oita, -1},
	/* CT8: (1999.1) */
	{wakayama, osaka, hyogo, okayama, hirosima, yamaguchi,
	 oita, miyazaki, -1},
	/* CT9: */
	{yamaguchi, ehime, okinawa, -1},
	/* CT0: */
	{kagosima, -1}
};

/* ץΥǡ */
static const char *ct_p[] = {
	"ɸץ",
	"äȥ",
	"ߥߥXS", /* 䡼ȡץɬ */
	"ߥߥS",
	"ߥߥL",
	NULL
};

static const char *ct_tacs_p[] = {
	"ɸץ",
	"äȥ",
	"ߥߥS",
	"ߥߥL",
	NULL
};

static const char *ct8_tacs_p[] = {
	"ɸץ",
	"äȥ",
	"ߥߥS",
	"ߥߥL",
	"ץ", /* ̳ƻ͹Τ */
	NULL
};

static const char *ct0_pdc8_p[] = {
	"ɸץ",
	"äȥ",
	"ߥߥXS",
	"ߥߥS",
	"ߥߥL",
	"B.B.ץ", /* Τ */
	NULL
};

static const char *ct_cdma_p[] = {
	"ɸץ",
	"äȥ",
	"ߥߥS",
	"ߥߥL",
	"ߥߥ른",
	NULL
};

static int ct_pp_px[][5] = {
	/* ݶ, (ݶñ)ʿ, ʿ, ,  */
	0,	10,	10,	10,	10, /* 0 ɸץ */
	0,	14,	10,	10,	10, /* 1 äȥ */
	2,	40,	40,	40,	40, /* 2 ߥߥS */
	2,	30,	30,	30,	30, /* 3 ߥߥL */
	0,	25,	25,	25,	25, /* 4 (̳ƻ͹Τ) ץ */
	2,	20,	20,	20,	20, /* 5 cdmaOneߥߥ른 */
	0,	25, 25, 25, 25,	/* 6 () IDOΥߥ */
	0,	24,	24,	24,	24, /* 7 (Τ) B.B.ץ */
	2,	50,	50,	50,	50, /* 8 ߥߥXS */
};

static const int plan_tacs2pp[] = {
	0, /* ɸ */
	1, /* ä */
	2, /* S */
	3, /* L */
	4, /* (̳ƻ͹Τ)ץ */
	0,
	6, /*  IDOΥΥߥ */
};

static const int plan_pdc82pp[] = {
	0, /* ɸ */
	1, /* ä */
	8, /* XL */
	2, /* S */
	3, /* L */
	7, /* (Τ)B.B.ץ */
	6, /*  IDOΥΥߥ */
};

static const int plan_cdma2pp[] = {
	0, /* ɸ */
	1, /* ä */
	2, /* S */
	3, /* L */
	5, /*  */
};

static const int ct_roam2docomo[][2] = {
	/* бɥΥץ, ۴ */
	DO_PDC8_PLAN_A, 270, /* ɸץ */
	DO_PDC8_PLAN_B, 210, /* äȥ */
	DO_PDC8_PLAN_B, 210, /* ߥߥS */
	DO_PDC8_PLAN_A, 270, /* ߥߥL */
	-1, -1, /* ߡ */
	-1, -1, /* ߡ */
	-1, -1, /* ߡ */
	-1, -1, /* 쥻顼ϥɥߥ󥰤ϼ»ܤƤʤ? */
	DO_PDC8_PLAN_B, 210, /* ߥߥXS ??? */
};

static const int ct_roam2ido[] = {
	/* бIDOΥץ */
	IDO_PLAN_STD, /* ɸץ */
	IDO_PLAN_SP_CHOTTO, /* äȥ */
	-1, /* ߥߥS */
	-1, /* ߥߥL */
	IDO_PLAN_SP_STDx25, /* ɸץx2.5̥ץ */
	-1,  /* ߥߥ른 */
	-1, /* ߡ */
	IDO_PLAN_SP_STDx24, /* ɸץx2.4̥ץ */
	-1, /* ߥߥXS */
};

static int ct_tacs_info[9][MAX_PLAN][2] = {
	{ /* CT1: (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3800, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{2500, 0}, /* (̳ƻ͹Τ) ץ */
		{-1, -1}
	}, { /* CT2 ѥ1998-12 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT4 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3800, 1400}, /* ߥߥS */
		{5600, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT6 ѥ 1999.01 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{5700, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT7 ѥ1999.1 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3800, 1400}, /* ߥߥS */
		{5600, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT8 ѥ1999.1 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3800, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{2500, 0}, /* (̳ƻ͹Τ) ץ */
		{-1, -1}
	}, { /* CT9 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3800, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT0 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{3800, 1400}, /* ߥߥS */
		{5600, 3000}, /* ߥߥL */
		{-1, -1}
	}
};

static int ct_pdc8_info[9][MAX_PLAN][2] = {
	{ /* CT1: (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3800, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT2 ѥ1998.12 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3900, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT4 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3800, 1400}, /* ߥߥS */
		{5600, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT6 ѥ1999.1 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3900, 1400}, /* ߥߥS */
		{5700, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT7 ѥ1999.1 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3800, 1400}, /* ߥߥS */
		{5600, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT8 ѥ1999.1 */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3800, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT9 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3800, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{-1, -1}
	}, { /* CT0 (http) */
		{4400, 0}, /* ɸץ */
		{3400, 0}, /* äȥ */
		{2700, 1000}, /* ߥߥXS */
		{3800, 1400}, /* ߥߥS */
		{5600, 3000}, /* ߥߥL */
		{2200, 0}, /* (Τ) B.B.ץ */
		{-1, -1}
	}
};

static int ct_cdma_info[9][MAX_PLAN][2] = {
	{ /* CT1: */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{6000, 3000}, /* ߥߥL */
		{9000, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT2 (http) */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{4000, 1400}, /* ߥߥS */
		{6000, 3000}, /* ߥߥL */
		{9000, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT4 */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{8800, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT6 ѥ1998.11 */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{4000, 1400}, /* ߥߥS */
		{5900, 3000}, /* ߥߥL */
		{8900, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT7 */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{5900, 3000}, /* ߥߥL */
		{9000, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT8 */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{6000, 3000}, /* ߥߥL */
		{9000, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT9 (http) */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{6000, 3000}, /* ߥߥL */
		{9000, 4000}, /* ߥߥ른 */
		{-1, -1}
	}, { /* CT0 */
		{4600, 0}, /* ɸץ */
		{3500, 0}, /* äȥ */
		{3900, 1400}, /* ߥߥS */
		{5800, 3000}, /* ߥߥL */
		{8800, 4000}, /* ߥߥ른 */
		{-1, -1}
	}
};

/* ǡ */
static float ct_std_time[][6][4] = {
/*	Ķȶ⡦ܸ
	¾
	顼ۥƱ
	ӡư
	Уȣ
	(ȼ֥ƥ) this is obsolete!!
ν(⤬¸ߤʤȤ-1) */
/* 	äϡȤꤢ̵뤷 */
/* : http://www.ddi.co.jp/cellular/fee_m.html */

/* CT1: */
/*	ʿ  ʿ     */
	20.0,	26.0,	29.0,	40.0,
	16.0,	20.0,	22.5,	31.5,
	15.0,	24.0,	26.5,	36.5,
	14.0,	23.5,	25.5,	35.0,
	12.5,	19.5,	19.5,	19.5,
	-1,	-1,	-1,	-1,
/* CT2: */
	22.5,	30.5,	34.5,	47.5,
	20.0,	26.5,	30.0,	41.5,
	16.5,	27.0,	30.0,	41.5,
	16.0,	26.5,	29.0,	40.0,
	13.0,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1,
/* CT4: (http) */
	23.0,	32.5,	36.5,	50.0,
	16.0,	20.0,	22.5,	31.5,
	18.0,	29.0,	32.5,	45.0, /* ϰ⡦ܤΥ顼(IDO) */
	17.0,	28.5,	31.0,	42.5,
	13.0,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1,
/* CT6: (http) */
	23.5,	32.5,	36.5,	50.0,
	16.0,	20.0,	22.5,	31.5,
	18.0,	29.0,	32.5,	45.0, /* ϰ⡦ܤΥ顼(IDO) */
	16.0,	26.5,	29.0,	40.0,
	13.0,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1,
/* CT7: (http) */
	22.5,	30.5,	34.5,	47.5,
	16.0,	20.0,	22.5,	31.5,
	17.0,	27.5,	31.0,	42.5, /* ϰ⡦ܤΥ顼(IDO) */
	16.0,	26.5,	29.0,	40.0,
	13.0,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1,
/* CT8: */
	22.5,	32.5,	36.5,	50.0,
	16.0,	20.0,	22.5,	31.5,
	17.5,	29.0,	32.0,	44.0, /* ϰ⡦ܤΥ顼(IDO) */
	17.0,	28.5,	31.0,	42.5,
	13.0,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1,
/* CT9: */
	24.0,	32.5,	36.5,	50.0,
	16.5,	20.0,	22.5,	31.5,
	18.5,	29.0,	32.5,	45.0, /* ϰ⡦ܤΥ顼(IDO) */
	17.0,	28.5,	31.0,	42.5,
	13.5,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1,
/* CT0: */
	24.0,	32.5,	36.5,	50.0,
	21.5,	29.0,	32.5,	45.0,
	18.5,	29.0,	32.5,	45.0, /* ϰ⡦ܤΥ顼(IDO) */
	17.0,	28.5,	31.0,	42.5,
	13.5,	21.0,	21.0,	21.0,
	-1,	-1,	-1,	-1
};

const char **cellular_ls_plan(int i, int d)
{
	switch (d) {
	case CDMAONE:
		return &(ct_cdma_p[0]);
	case TACS:
		if (i == CT1 || i == CT8) {
			/* ̳ƻ͹ˤϤץ󤬤 */
			return &(ct8_tacs_p[0]);
		}
		return &(ct_tacs_p[0]);
	case PDC8:
		if (i == CT0) {
			/* ˤB.B.ץ󤬤 */
			return &(ct0_pdc8_p[0]);
		}
		return &(ct_p[0]);
	} /* switch */
	return NULL;
} /* end of func */

const int *cellular_getinfo_plan(int i, int d, int plan)
{
	switch (d) {
	case CDMAONE:
		return &(ct_cdma_info[i-CT1][plan][0]);
	case PDC8:
		return &(ct_pdc8_info[i-CT1][plan][0]);
	case TACS:
		return &(ct_tacs_info[i-CT1][plan][0]);
	}
	return NULL;
} /* end of func */

void cellular_calc_charge(long *result, long tm, int tm2, 
int h_ken, int t_ken, int ca, int denpa, int plan, int roam_c)
{
	int h; /* ȯΥ顼 */
	int r_ar = 0; /* or */
	int *px;
	float *stdt;
	int roam_plan, roam_denpa;
	void (*calc_r)(long, int, long *, float *, int *);

	/*  */
	const int *p;
	int j;

	switch (denpa) {
	case CDMAONE:
		plan = plan_cdma2pp[plan];
		break;
	case PDC8:
		plan = plan_pdc82pp[plan];
		break;
	case TACS:
		plan = plan_tacs2pp[plan];
		break;
	}

	p = ls_carrier_ken(h_ken);
	do {
		h = *p++;
		if (h < 0) break;
	} while (groupof_carrier(h) != CELLULAR);
	/*  h ȯΥ顼or -1 ˤʤ */

	if (h < 0) { /* ߥ */
		if (groupof_carrier(roam_c) == DOCOMO) {
			if (ca == CT0) {
				/* ϥɥߥ󥰤ʤ */
				result[0] = 2;
				return;
			}
			switch(denpa) {
			case PDC8:
				roam_plan = ct_roam2docomo[plan][0];
				docomo_calc_charge(result, tm, tm2, h_ken, t_ken,
					roam_c, denpa, roam_plan, -1);
				result[3] = ct_roam2docomo[plan][1]; /* ۴Υå */
				if (plan == CT_PLAN_KOMI_L || plan == CT_PLAN_KOMI_S)
					result[1] |= 0x4; /* ߥߥץ̵ʬ˴ޤޤʤ */
				return;
			default:
			/* 顼 */
				result[0] = 2;
				return;
			}
		}
		if (roam_c == IDO) {
			roam_plan = ct_roam2ido[plan];
			if (denpa == CDMAONE) roam_denpa = PDC8;
			else roam_denpa = denpa;

			if (roam_plan >= 0) {
				ido_calc_charge(result, tm, tm2, h_ken,
					t_ken, IDO, roam_denpa, roam_plan, -1);
				return;
			} else {/* ߥߥIDOߥ󥰤ǤƱ */
				h = ca; /* ȯꥢ */
			}
		}
	} /* if (h) */

	p = ls_system(h);
	do {
		j = *p++;
		if (j < 0) {
			result[0] = 2; /* 顼 */
			result[7] = 0;
			return;
		}
	} while (j != denpa);

	/* h0Ϥޤͤˤ */
	h -= CT1;

	/* Ķȶ⡦ܤǤ뤫ɤå */
	r_ar = is_kuikinai_rinsetu(h + CT1, t_ken, &(ct_rinsetu[h][0]));
	/*	printf("DEBUG0\n"); */

	stdt = &(ct_std_time[h][0][0]);
	px = &(ct_pp_px[plan][0]);

	if (px[0] == 2) { /* ߥߥ */
		calc_r = komi_calc;
	} else { /* ¾Υץ */
		calc_r = common_std_calc;
	}
	/*	printf("DEBUG1\n");	*/

	/* ¸֤ޤPHS */
	calc_r(tm, tm2, &(result[20]), &(stdt[16]), px);
	/* ȼ⤬¸ߤʤ׻ */
	if (stdt[20] >= 0) {
		calc_r(tm, tm2, &(result[24]), &(stdt[20]), px);
		result[1] |= 0x1;
		result[7] = 20;
	} else {
		result[7] = 16;
	}
	/*	printf("DEBUG_PHS\n"); */

	/* ̲ø */
	if (r_ar > 0) { /* ⡦ */
		calc_r(tm, tm2, &(result[8]), &(stdt[0]), px);
	} else { /* ¾θ */
		calc_r(tm, tm2, &(result[8]), &(stdt[4]), px);
	}
	/*	printf("DEBUG_IPPAN\n"); */

	/* 顼ۥˤ */
	if (stdt[8] >= 0 && r_ar > 0) {
		result[2] = CELLULAR;
		calc_r(tm, tm2, &(result[12]), &(stdt[8]), px);
	} else {
		result[2] = -1;
		calc_r(tm, tm2, &(result[12]), &(stdt[12]), px);
	}
	/*	printf("DEBUG_CT %f %d\n", stdt[8], r_ar); */

	/* ø */
	calc_r(tm, tm2, &(result[16]), &(stdt[12]), px);
	/*	printf("DEBUG_KEITAI\n"); */

	return;
} /* end of func */

static void komi_calc(long tm, int tm2, long *r, 
float *stdt, int *px)
{
	int i;

	if (tm + tm2 <= 10) { /* 10ðä10 */
		r[0] = 10;
		r[1] = 10;
		r[2] = 10;
		r[3] = 10;
		return;
	}

		r[0] = px[1];
		r[1] = px[1];
		r[2] = px[1];
		r[3] = px[1];

	if (tm + tm2 <= 60) return;

	for (i=0; i<4; i++) {
	r[i] += px[1] * (1 + ((tm + tm2) - 61) / 60);
	}
	return;

} /* end of this func */

