/* kfunc2.c 19990418 19990606 19990808 */
static const long revision = 19990808;

#include <stdio.h>
#include "k_defs.h"
#include "keitai.h"
#include "k_priv.h"

#define bigger_value(a, b)  (((a) > (b)) ? (a) : (b))

long k_version(void)
{
	long max;

	max = revision;
	max = bigger_value(docomo_revision, max);
	max = bigger_value(cellular_revision, max);
	max = bigger_value(ido_revision, max);
	max = bigger_value(tjd_revision, max);

	return max;
} /* end of func */

int carrier_group_ken(int g, int ken)
{
	const int *a;

	a = ls_carrier_ken(ken);

	while (*a >= 0) {
		if (groupof_carrier(*a) == g) return *a;
		a++;
	}

	return -1;
} /* end of this func */

int time_to_t4(int tx, int hour, int min, int wd)
{
	int r = 0;

	switch(tx) {
	case TIME_STD:
		if (hour < 8)                               r = 3; /*  */
		else if (wd == 0 && hour >=8  && hour < 19) r = 0; /* ʿ */
		else if (wd == 0 && hour >=19 && hour < 23) r = 1; /* ʿ */
		else if (wd == 1 && hour >=8  && hour < 23) r = 2; /*  */
		else /* if (hour >=23) */                   r = 3; /*  */
		break;
	case TIME_N1:
		if (hour < 8)                               r = 3; /*  */
		else if (wd == 0 && hour >=8  && hour < 17) r = 0; /* ʿ */
		else if (wd == 0 && hour >=17 && hour < 19) r = 1; /* ʿ */
		else if (wd == 1 && hour >=8  && hour < 19) r = 2; /*  */
		else /* if (hour >=19) */                   r = 3; /*  */
		break;
	case TIME_N2:
		if (wd == 0 &&
			(	(hour >=9 && hour*60 + min < 11*60 + 30)
			||	(hour*60 + min >= 13*60 + 30 && hour < 17) ) )
			r = 0; /* ӥͥ */
		else r = 2; /* ޥ */
		break;
	case TIME_N3:
		if (hour*60 + min >= 11*60 + 30 &&
			hour*60 + min < 13*60 + 30) r = 2; /*  */
		else r = 0; /* ʿ */
		if (wd == 1) r = 2; /*  */
		if (hour < 8 || hour >= 23) r = 3; /*  */
		break;
	case TIME_N4:
		if (hour >= 7 && hour < 21) {
			if (wd == 0) r = 0;
			else r = 2;
		}
		else if (hour >= 21 && hour < 24) r = 1;
		else /* if (hour < 7 || hour == 24) */ r = 3;
		break;
	case TIME_N5:
		if (hour < 8 || hour >= 22) r = 3;
		else r = 0;
		break;
	case TIME_N6:
		if (wd == 0 && hour >= 9 && hour < 17) r = 0;
		else r = 2;
		break;
	case TIME_N7:
		if (wd == 0 && hour*60 + min >= 11*60 + 30 &&
			hour*60 + min < 13*60 + 30) r = 2; /* ʿ11:30-13:30 */
		else r = 0; /* ʿ */
		if (wd == 1) r = 2; /*  */
		if (hour < 8 || hour >= 23) r = 3; /*  */
		break;
	case TIME_N8:
		if (hour < 8 || hour >= 20) r = 3;
		else r = 0;
		break;
	case TIME_N9:
		if (hour < 8 || hour >= 17) r = 3;
		else r = 0;
		break;
	/* default:
		r = 0;
		break;
	*/
	}

	return r;
} /* end of func */

int *ls_system_roaming(int x, int y)
{
	static int r[5];
	const int *p;
	const int *q;
	int i, j;

	for (i=0; i<5; i++) r[i] = 0;

	p = ls_system(x);
	q = ls_system(y);

	for (i = 0; *p >= 0; p++) {
		for (j = 0; q[j] >= 0; j++) {
			if (*p == q[j]) r[i++]=*p;
		}
	}

	r[i] = -1;
	return r;
} /* end of this func */

const char **ls_plan(int i, int d)
{
	int g;

	g = groupof_carrier(i);

	switch (g) {
		case DOCOMO:
			return docomo_ls_plan(i, d);
		case IDOG:
			return ido_ls_plan(i, d);
		case CELLULAR:
			return cellular_ls_plan(i, d);
		case TUKA:
		case JPHONE:
		case DIGITU:
			return tjd_ls_plan(i, d);
	}

	return NULL;
} /* end of func */

const int *getinfo_plan(int i, int d, int plan)
{
	int g;

	g = groupof_carrier(i);

	switch (g) {
		case DOCOMO:
			return docomo_getinfo_plan(i, d, plan);
		case IDOG:
			return ido_getinfo_plan(i, d, plan);
		case CELLULAR:
			return cellular_getinfo_plan(i, d, plan);
		case TUKA:
		case JPHONE:
		case DIGITU:
			return tjd_getinfo_plan(i, d, plan);
	}

	return NULL;
} /* end of func */

long *calc_charge(long tm, int tm2, int h_ken, int t_ken, int ca, 
	int denpa, int plan, int roam_c)
{
#define NUMOF_RESULT	36
	int i;
	int g;
	static long result[NUMOF_RESULT];

	for (i = 0; i < NUMOF_RESULT; i++) {
		result[i] = 0;
	}

	g = groupof_carrier(ca);

	switch (g) {
	case DOCOMO:
		docomo_calc_charge(result, tm, tm2, h_ken, t_ken, ca, 
		denpa, plan, roam_c);
		break;
	case IDOG:
		ido_calc_charge(result, tm, tm2, h_ken, t_ken, ca, 
		denpa, plan, roam_c);
		break;
	case CELLULAR:
		cellular_calc_charge(result, tm, tm2, h_ken, t_ken, ca, 
		denpa, plan, roam_c);
		break;
	case TUKA:
	case JPHONE:
	case DIGITU:
		tjd_calc_charge(result, tm, tm2, h_ken, t_ken, ca, 
		denpa, plan, roam_c);
		break;
	default:
		return NULL;
	}

	return result;

} /* end of this func */

/* ̲֥롼 */
void common_std_calc(long tm, int tm2, long *r, float *stdt, int *px)
{
	int i;
	long l;
	double f;

	for (i=0; i<4; i++) {
		f = tm + tm2 * 0.5;
		l = f / stdt[i];
		if ((double)l * stdt[i] - f < 0.0) l+=1;
		r[i] = px[i+1] * l;
	}

	return;
} /* end of this func */

int is_kuikinai_rinsetu(int h, int t_ken, const int *rinsetu)
{
	const int *p;
	int i, j;

	p = areaof_carrier(h);
	do {
		j = *p++;
		if (j == t_ken) {
			return 1; /*  */
		}
	} while (j >= 0);

	i = 0;
	do {
		j = rinsetu[i++];
		if (j == t_ken) {
			return 2; /*  */
			break;
		}
	} while (j >= 0);

	return 0; /* ʤ */

} /* end of func */
