/* kmat.c 19990214 19990606 19990808 19991206 */
static const char *version="v0.0.6";
#define PROGNAME	" "
#define CGI_CREDIT	"kmat.cgi"
#define COPYRIGHT	"(C)1999 GOTO Naohisa"

#ifdef CGI
	#undef CGI
	#define CGI	1
	#define CMDLINE	0
	#define HTML	1
#else /* CGI */
	#define CGI	0
	#define CMDLINE	1
	#define HTML	0
#endif /* CGI */

#ifdef CMDLINE_HTML
	#undef CGI
	#undef CMDLINE
	#undef HTML
	#define CGI	0
	#define CMDLINE	1
	#define HTML	1
#endif /* CMDLINE_HTML */

#define PADSPCS	"  "
#define CGI_LOGFILE	"kmat.log"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"
#if CGI
	#include "cgi_com.h"
	#include "genfnc.h"
#endif /* CGI */

/* ХʴؿΥץȥ */
int td_to_t4(int tx, int td, int wd);
long *calc_result(long *ch, int a, int h_kinkyori);
int checkarea_astel(int tken);

/* ץȥ */
static void select_intro(void);
static int select_td(void);
static int checkrange_tdwd(int td, int wd);

void kmat_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori);
void kmat_print_main2(long tm, int tm2, int hken, int tken,
 int td, int wd, int ca, int h_kinkyori);
static void print_plan(const char *p, int ca, int denpa, int plan);
static void print_charge(long *ch, int td, int wd, int tken, int h_kinkyori);
static void print_dst(void);
static void print_dst_info(void);

#if HTML
static void html_start(char *title);
static void html_end(void);
#endif /* HTML */

/* ¾ΥեƤؿ */
extern void kmat_html_tbl_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori);
extern void kmat_csv_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori);

/* Хѿ */
const char *td_str[12] = {
		"0:00-7:00",
		"7:00-8:00",
		"8:00-9:00",
		"9:00-11:30",
		"11:30-13:30",
		"13:30-17:00",
		"17:00-19:00",
		"19:00-20:00",
		"20:00-21:00",
		"21:00-22:00",
		"22:00-23:00",
		"23:00-0:00"
};

int my_printf(const char *format, ...)
{
	int i;
	va_list arg;

	va_start(arg, format);
	i = vprintf(format, arg);
	/* sprintfˤϡvsprintf(buf, format, arg) ˤ롣*/
	va_end(arg);

	return i;
} /* end of func */

int stderr_printf(const char *format, ...)
{
	int i;
	va_list arg;

	va_start(arg, format);
	i = vfprintf(stderr, format, arg);
	va_end(arg);

	return i;
} /* end of func */

int main(int argc, char *argv[])
{
	int chiiki, eken, hken, tken, td, wd;
	double f;
	long tm;
	int tm2;
	int h_kinkyori = 0;

	int output_format = 0;
	int print_kihon = 1;
	int r;
	int err = 0;

#if CGI
	char *form;
	long min;
	int err1 = 0, err2 = 0;
#endif /* CGI */

#if CMDLINE
	my_printf(PROGNAME " %s+keitai.lib %ld\n", version, k_version());
	my_printf(COPYRIGHT "\n");
#endif /* CMDLINE */

	/*  */
#if CMDLINE
	select_intro();

	chiiki = select_chiiki();
	eken = chiiki2eken(chiiki);

	show_todofuken();
	hken = select_num(1, 47, "ȯƻܸ? ") -1;

	show_todofuken();
	tken = select_num(0, 47, "ä򤫤ƻܸ? ") -1;
	if (tken == -1) tken = hken; /* 0ϤȡƱ */

	if (hken == hokkaido && tken == hokkaido) {
	/* ̳ƻɤξ硢Υʳ */
		h_kinkyori = 2 - select_num(1, 2, 
					"̳ƻäξ 1.Υ 2.ʳ ? ");
	}

	td = select_td();
	wd = select_num(1, 2, "1: ʿ() 2: () ? ") -1;
	/* ʿΤȤwd=0, ΤȤwd=1 */

	f = inp_time();
	double2tm(f, &tm, &tm2);
#endif /* CMDLINE */

#if CGI
	cgi_initform(); /* եν */

	form = cgi_getform("chiiki");
	err += text2int(form, &chiiki, 0);
	chiiki -= 1;
	eken = chiiki2eken(chiiki);

	form = cgi_getform("hken");
	err += text2int(form, &hken, -1);
	hken -= 1;

	form = cgi_getform("tken");
	err += text2int(form, &tken, -1);
	tken -= 1;
	if (tken == -1) tken = hken; /* Ʊ츩 */

	form = cgi_getform("hkk");
	text2int(form, &h_kinkyori, 0);
	/* hkk̵Ƥ⥨顼ˤʤ */
	/* եh_kinkyori-1ʤ */

	form = cgi_getform("td");
	err += text2int(form, &td, -1);
	td -= 1;

	form = cgi_getform("wd");
	err += text2int(form, &wd, -1);
	/* եwd-1ʤ */

	f = 0; /* ǰΤ */
	form = cgi_getform("tm");
	if (form == NULL) {
		err1 = 1;
	} else {
		r = sscanf(form, "%lf", &f);
		if (r != 1) err1 = 1;
	}
	double2tm(f, &tm, &tm2);

	form = cgi_getform("min");
	if (form == NULL) {
		err2 = 1;
	} else {
		r = sscanf(form, "%ld", &min);
		if (r != 1) err2 = 1;
	}
	if (err2 == 0) tm = tm + min * 60; /* ʬñ̤λ֤­ */
	if (err1 && err2) err = 1;

	form = cgi_getform("ot");
	err += text2int(form, &output_format, 1);

	form = cgi_getform("kh");
	err += text2int(form, &print_kihon, 1);

	/*  */
	cgi_accounting(CGI_LOGFILE);
#endif /* CGI */

	/*  */
	set_print_kihon(print_kihon);

	/* ϰϥå */
	r = checkrange_tm(tm, tm2)
		+ checkrange_ken(eken, hken, tken)
		+ checkrange_chiiki(chiiki)
		+ checkrange_tdwd(td, wd);

	if (r || err) {
#if HTML
		html_start("ERROR: out of range");
		my_printf(
			"<h1>顼 : ϰϳοͤǤ</h1>\n"
			);
		html_end();

#else /* HTML */
		my_printf("顼: ϰϳοͤǤ\n");
#endif /* HTML */

		return 1;
	}

	/* ɽ */
#if CMDLINE
	my_printf("\n");
#endif /* CMDLINE */
#if HTML
	html_start("result");
#endif /* HTML */

#ifdef CMDLINE_HTML
	output_format = 1;
#endif /* CMDLINE_HTML */

	switch(output_format) {
#if HTML
	case 1: /* table */
		kmat_html_tbl_print_main(tm, tm2, eken, hken, tken, td, wd,
			chiiki_str[chiiki], h_kinkyori);
		break;
#endif /* HTML */
#if CGI
	case 2: /* CSV */
#if HTML
		my_printf("<pre>\n");
#endif /* HTML */
		kmat_csv_print_main(tm, tm2, eken, hken, tken, td, wd,
			chiiki_str[chiiki], h_kinkyori);
#if HTML
		my_printf("\n");
		my_printf("</pre>");
#endif /* HTML */
		break;
#endif /* CGI */
	case 0:
	default:
#if HTML
	my_printf("<pre>");
#endif /* HTML */
		kmat_print_main(tm, tm2, eken, hken, tken, td, wd,
			chiiki_str[chiiki], h_kinkyori);
#if HTML
	/* my_printf("\n"); */
	my_printf("</pre>");
#endif /* HTML */
		break;
	}

#if HTML
#if CGI
	my_printf("<hr>\n");
	my_printf(CGI_CREDIT " %s + keitai.lib %ld"
		, version, k_version());
	my_printf(" " COPYRIGHT "<br>\n");
#endif /* CGI */
	html_end();
#endif /* HTML */

	return 0;
} /* end of main() */

#if CMDLINE
/*  */
static void select_intro(void)
{
	stderr_printf("\n");
	stderr_printf("ꤷϰǱĶȤƤҤˤĤ"
		"̤ɽޤ\n");
} /* end of func */

static int select_td(void)
{
	int i;
	int td;

	for (i = 0; i < 12; i++) {
		stderr_printf("%2d: %s\n", i+1, td_str[i]);
	}

	/* stderr_printf("\n"); */
	td = select_num(1, 12, "Ӥ򤷤Ƥ ") -1;

	return td;
} /* end of func */
#endif /* CMDLINE */

static int checkrange_tdwd(int td, int wd)
{
	if (td >= 12 || td < 0) return 1;
	if (wd != 0 && wd != 1) return 2;

	return 0; /*  */
} /* end of func */

/* ɽᥤ */
void kmat_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori)
{
	int i;
	long min, tmx;
	const int *clist;
	int ca;

	clist = ls_carrier_ken(eken);

	/* ǽηޤʸɽ */
	my_printf("%sǱĶȤƤ\n", cstr);

	for (i=0; clist[i] >= 0 ; i++) {
		my_printf("        %s\n", nameof_carrier(clist[i]));
	}
	my_printf("ˤĤơ");
	my_printf("%s%s",
		wd ? "()" : "ʿ()", 
		td_str[td]);

	my_printf("%s%s",nameof_pref(hken), nameof_pref(tken));
	if (hken == hokkaido && tken == hokkaido) {
		if (h_kinkyori) my_printf("ζΥ");
		else my_printf("(Υʳ)");
	}
	my_printf("ؤȤ\n");

	min = tm / 60;
	tmx = tm - min * 60;
	if (min >= 1) my_printf("%ldʬ", min);
	if (tmx + tm2 > 0) my_printf("%ld%s", tmx, tm2 ? ".5" : "");
	if (min >= 1) my_printf("(%ld%s)", tm, tm2 ? ".5" : "");
	my_printf("֤ɽޤ(ñ:)\n");

	/* ᥤξɽ */
	for (i=0; ; i++) {
		ca = clist[i];
		if (ca < 0) break;
		kmat_print_main2(tm, tm2, hken, tken, td, wd, ca, h_kinkyori);
	}

	/* Ǹηޤʸɽ */
	my_printf("\n");
	print_dst_info();
	my_printf("\n");
	print_notice_txt();

	return;
} /* end of func */

void kmat_print_main2(long tm, int tm2, int hken, int tken,
 int td, int wd, int ca, int h_kinkyori)
{
	int j, k, r;
	int roam_c, ca2;
	const int *dlist;
	const int *rlist;
	const char **plist;
	long *ch;

	r = -1;
	rlist = roaming_carrier(ca, hken);
	do {
		r++;
		my_printf("\n");
		roam_c = rlist[r];
		my_printf("%s", nameof_carrier(ca));
		if (roam_c >= 0) {
			dlist = ls_system_roaming(ca, roam_c);
			my_printf(" : %s˥ߥ\n", nameof_carrier(roam_c));
		} else {
			dlist = ls_system(ca);
			ca2 = carrier_group_ken(groupof_carrier(ca), hken);
			if (ca != ca2) {
				my_printf(" ( -> %s)\n", nameof_carrier(ca2));
			} else {
				my_printf("\n");
			}
		} /* if (roam_c) */

		for (j=0; dlist[j] >= 0; j++) {
			my_printf(" < %s >\n", nameof_system(dlist[j]));
			print_dst(); /* ɽ */
			plist = ls_plan(ca, dlist[j]);
			for (k=0; plist[k] != NULL; k++) {
				ch = calc_charge(tm, tm2, hken, tken, ca, 
					dlist[j], k, roam_c);
				if (ch[0] == 1) {
					my_printf(PADSPCS "  ĶȥꥢǤ\n");
					break; /* for */
				}
				print_plan(plist[k], ca, dlist[j], k);
				print_charge(ch, td, wd, tken, h_kinkyori);
			} /* for(k) */
		} /* for(j) */
	} while (roam_c >= 0 && rlist[r+1] >= 0);

	return;
} /* end of func */

/* ɽϤδؿ  */
static void print_plan(const char *p, int ca, int denpa, int plan)
{
	const int *a;

	a = getinfo_plan(ca, denpa, plan);

	my_printf("%-28s", p);

	if (is_print_kihon()) {
		my_printf("  ܻ %d", a[0]);
		if (a[1] > 0) my_printf("  %dʬ", a[1]);
	}

	my_printf("\n");
	return;
} /* end of func */

static void print_charge(long *ch, int td, int wd, int tken,
 int h_kinkyori)
{
	int a, i;
	long *r;

	a = td_to_t4(ch[4], td, wd);
	r = calc_result(ch, a, h_kinkyori);

	my_printf(PADSPCS);
	for (i = 0; i <= 1 ; i++) {
		my_printf("%9ld ", r[i]);
	}

	if (checkarea_astel(tken)) /* 忮Ϥ¸֥ƥΥꥢ */
		my_printf("%9ld ", r[2]);
	else
		my_printf("%9s ", "---");

	for (i = 3; i < 7; i++) {
		my_printf("%9ld ", r[i]);
	}
	my_printf("\n");

	if ((ch[1] & 0x4) != 0) { /* ̵ʬ˴ޤޤʤ */
		my_printf(PADSPCS "*ϡ"
				"ܻߤ̵ʬ˴ޤޤޤ\n");
	}

	if (ch[3] != 0) { /* ۴(IDO顼Υɥߥ) */
		my_printf(PADSPCS "*۴%ldߤɬס\n", ch[3]);
	}

	return;
} /* end of func */

static void print_dst(void)
{
	my_printf(PADSPCS
	"                                         CELLULAR    JPHONE      TUKA"
	"\n" PADSPCS
	"      NTT     PHS_U     PHS_I    DOCOMO       IDO  DIGITU_J  DIGITU_T"
	"\n");

	return;
} /* end of func */

static void print_dst_info(void)
{
	my_printf("\n"
		"  NTT:      ̲\n"
		"  PHS_U:    DDIݥåȳƼ, NTTɥƼҤPHS,\n"
		"            ƥ񡦶彣\n"
		"  PHS_I:    ƥ̳ƻ̡͹\n"
		"  DOCOMO:   NTTɥη\n"
		"  CELLULAR: 顼Ƽ\n"
		"  IDO:      IDO(ܰư̿)\n"
		"  JPHONE:   ե쳤(ǥۥƼ)\n"
		"  DIGITU_J: ե̳ƻ̡Φ񡦻͹񡦶彣\n"
		"            (ǥġƼ)Τߥ󥰥롼פ\n"
		"            J-եͥåȥεξ\n"
		"  TUKA:     ġ顼쳤, ġۥ\n"
		"  DIGITU_T: ե̳ƻ̡Φ񡦻͹񡦶彣\n"
		"            (ǥġƼ)Τߥ󥰥롼פ\n"
		"            ġͥåȥεξ\n"
		);

	return;
} /* end of func */

/* Хؿ */
long *calc_result(long *ch, int a, int h_kinkyori)
{
	static long r[7];

	/* ̲ */
	if (h_kinkyori && (ch[1] & 0x8)) { /* Υ⤬¸ */
		r[0] = ch[32 + a];
	} else {
		r[0] = ch[8 + a];
	}

	/* ¸PHS */
	r[1] = ch[20 + a];

	/* ȼPHS */
	if ((ch[1] & 0x1)) { /* ¸֤ȼ֤ۤʤ */
		r[2] = ch[24 + a];
	} else {
		r[2] = r[1];
	}

	/* NTTɥ */
	if (ch[2] == DOCOMO) {
		r[3] = ch[12 + a];
	} else {
		r[3] = ch[16 + a];
	}

	/* IDO顼 */
	if (ch[2] == IDO || ch[2] == CELLULAR) {
		r[4] = ch[12 + a];
	} else {
		r[4] = ch[16 + a];
	}

	/* ǥۥ(J-PHONE)ǥġ */
	if (ch[2] == JPHONE || ch[2] == DIGITU) {
		r[5] = ch[12 + a];
	} else {
		r[5] = ch[16 + a];
	}

	/* ġǥġ */
	if (ch[2] == TUKA || ch[2] == DIGITU) {
		r[6] = ch[12 + a];
	} else {
		r[6] = ch[16 + a];
	}

	return r;
} /* end of func */

int td_to_t4(int tx, int td, int wd)
{
	static const int td2time[][2] = {
		 1,  0, /* 0:00-7:00 */
		 7, 30, /* 7:00-8:00 */
		 8, 30, /* 8:00-9:00 */
		10,  0, /* 9:00-11:30 */
		12,  0, /* 11:30-13:30 */
		14,  0, /* 13:30-17:00 */
		18,  0, /* 17:00-19:00 */
		19,  30, /* 19:00-20:00 */
		20,  30, /* 20:00-21:00 */
		21, 30, /* 21:00-22:00 */
		22, 30, /* 22:00-23:00 */
		23, 30, /* 23:00-0:00 */
	};

	return time_to_t4(tx, td2time[td][0], td2time[td][1], wd);
} /* end of func */

int checkarea_astel(int tken)
/* 忮˥ƥȼ֤ΥꥢޤޤȤ0ʳ֤ */
{
	static const char is_astel[47] = {
		+1,	/* ̳ƻ */
		+1,	/* Ŀ */
		+1,	/* ĸ */
		+1,	/* 긩 */
		+1,	/*  */
		+1,	/* ܾ븩 */
		+1,	/* ʡ縩 */
		0,	/* ϸ */
		0,	/* ڸ */
		0,	/* 븩 */
		0,	/* ̸ */
		0,	/* ո */
		0,	/*  */
		0,	/*  */
		0,	/*  */
		+1,	/* 㸩 */
		0,	/* Ĺ */
		0,	/* ٻ */
		0,	/*  */
		0,	/* ʡ温 */
		+1,	/* 츩 */
		+1,	/* Ų */
		+1,	/* θ */
		+1,	/* Ÿ */
		0,	/* 츩 */
		0,	/*  */
		0,	/*  */
		0,	/* ɸ */
		0,	/* ²λ */
		0,	/* ʼ˸ */
		0,	/* Ļ踩 */
		0,	/*  */
		0,	/* 纬 */
		0,	/* 縩 */
		0,	/*  */
		+1,	/*  */
		+1,	/* 縩 */
		+1,	/* ɲ */
		+1,	/* θ */
		0,	/* ʡ */
		0,	/* 츩 */
		0,	/* Ĺ긩 */
		0,	/* ʬ */
		0,	/* ܸ */
		0,	/* ܺ긩 */
		0,	/* 縩 */
		0,	/* 츩 */
};

	return is_astel[tken];
} /* end of func */

#if HTML
/* HTMLؿ */
static void html_start(char *title)
{
#if CGI
	my_printf("Content-type: text/html\n");
	my_printf("\n");
#endif /* CGI */

	my_printf("<html><head>\n");
	my_printf("<title>%s</title>\n", title);
	my_printf("</head>\n");

	my_printf("<body bgcolor=\"a0c0e8\">\n");
	return;
} /* end of func */
static void html_end(void)
{
	my_printf("</body>\n");
	my_printf("</html>\n");
	return;
} /* end of func */
#endif /* HTML */
